'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _actions = require('./actions');

var _actions2 = _interopRequireDefault(_actions);

var _load_initial_state = require('./load_initial_state');

var _load_initial_state2 = _interopRequireDefault(_load_initial_state);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var subscribeViewModel = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref, action) {
    var origin = _ref.origin,
        rootPath = _ref.rootPath,
        store = _ref.store,
        adapter = _ref.adapter,
        viewModels = _ref.viewModels,
        subscribers = _ref.subscribers,
        requests = _ref.requests;
    var viewModelName, aggregateId, needChange, key, rawState, state;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            viewModelName = action.viewModelName, aggregateId = action.aggregateId;
            needChange = !subscribers.viewModels[viewModelName] || !subscribers.aggregateIds[aggregateId];


            subscribers.viewModels[viewModelName] = (subscribers.viewModels[viewModelName] || 0) + 1;
            subscribers.aggregateIds[aggregateId] = (subscribers.aggregateIds[aggregateId] || 0) + 1;

            if (!needChange) {
              _context.next = 12;
              break;
            }

            key = (0, _utils.getKey)(viewModelName, aggregateId);

            requests[key] = true;

            _context.next = 9;
            return (0, _load_initial_state2.default)({
              origin: origin,
              rootPath: rootPath
            }, viewModelName, aggregateId);

          case 9:
            rawState = _context.sent;
            state = viewModels.find(function (_ref3) {
              var name = _ref3.name;
              return name === viewModelName;
            }).deserializeState(rawState);


            if (requests[key]) {
              delete requests[key];

              store.dispatch(_actions2.default.merge(viewModelName, aggregateId, state));

              adapter.setSubscription({
                types: (0, _utils.getEventTypes)(viewModels, subscribers),
                aggregateIds: (0, _utils.getAggregateIds)(viewModels, subscribers)
              });
            }

          case 12:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function subscribeViewModel(_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();

exports.default = subscribeViewModel;
module.exports = exports['default'];