'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _utils = require('./utils');

var _actions = require('./actions');

var _actions2 = _interopRequireDefault(_actions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var unsubscribeReadModel = function unsubscribeReadModel(_ref, action) {
  var origin = _ref.origin,
      rootPath = _ref.rootPath,
      store = _ref.store,
      readModelSubscriptions = _ref.readModelSubscriptions,
      orderedFetch = _ref.orderedFetch;
  var readModelName = action.readModelName,
      resolverName = action.resolverName;

  var subscriptionKey = readModelName + ':' + resolverName;
  if (!readModelSubscriptions.hasOwnProperty(subscriptionKey)) return;

  var socketId = readModelSubscriptions[subscriptionKey].socketId;
  delete readModelSubscriptions[subscriptionKey];

  store.dispatch(_actions2.default.dropReadModelState(readModelName, resolverName));

  if (!socketId || socketId.constructor !== String) return;

  orderedFetch((0, _utils.getRootableUrl)(origin, rootPath, '/api/query/' + readModelName + '/' + resolverName + '?socketId=' + socketId), {
    method: 'DELETE',
    credentials: 'same-origin'
  }).catch(function () {
    return null;
  });
};

exports.default = unsubscribeReadModel;
module.exports = exports['default'];