'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _utils = require('./utils');

var unsubscribeViewModel = function unsubscribeViewModel(_ref, action) {
  var adapter = _ref.adapter,
      viewModels = _ref.viewModels,
      subscribers = _ref.subscribers,
      requests = _ref.requests;
  var viewModelName = action.viewModelName,
      aggregateId = action.aggregateId;


  subscribers.viewModels[viewModelName] = Math.max((subscribers.viewModels[viewModelName] || 0) - 1, 0);
  subscribers.aggregateIds[aggregateId] = Math.max((subscribers.aggregateIds[aggregateId] || 0) - 1, 0);

  var needChange = !subscribers.viewModels[viewModelName] || !subscribers.aggregateIds[aggregateId];

  var key = (0, _utils.getKey)(viewModelName, aggregateId);
  delete requests[key];

  if (needChange) {
    adapter.setSubscription({
      types: (0, _utils.getEventTypes)(viewModels, subscribers),
      aggregateIds: (0, _utils.getAggregateIds)(viewModels, subscribers)
    });
  }
};

exports.default = unsubscribeViewModel;
module.exports = exports['default'];