'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createOrderedFetch = exports.getAggregateIds = exports.getEventTypes = exports.makeLateResolvingPromise = exports.delay = exports.getKey = exports.getRootableUrl = exports.checkRequiredFields = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var checkRequiredFields = exports.checkRequiredFields = function checkRequiredFields(obj, beforeWarnings, afterWarnings) {
  var warningMessages = (0, _keys2.default)(obj).map(function (fieldName) {
    return obj[fieldName] ? null : 'The \'' + fieldName + '\' field is required';
  }).filter(function (msg) {
    return msg;
  });

  var shouldWarningsBePrinted = warningMessages.length > 0;

  if (shouldWarningsBePrinted) {
    // eslint-disable-next-line no-console
    console.warn([beforeWarnings].concat((0, _toConsumableArray3.default)(warningMessages), [afterWarnings]).filter(function (line) {
      return line;
    }).join('\n'));
  }

  return !shouldWarningsBePrinted;
};

var getRootableUrl = exports.getRootableUrl = function getRootableUrl(origin, rootPath, url) {
  return '' + origin + (rootPath ? '/' + rootPath : '') + url;
};

var getKey = exports.getKey = function getKey(viewModel, aggregateId) {
  return viewModel + ':' + aggregateId;
};

var delay = exports.delay = function delay(timeout) {
  return new _promise2.default(function (resolve) {
    return setTimeout(resolve, timeout);
  });
};

var makeLateResolvingPromise = exports.makeLateResolvingPromise = function makeLateResolvingPromise() {
  if (arguments.length > 1) {
    throw new Error('Make late-resolved promise accepts only zero on one argument');
  }

  var resolvePromise = null;
  var promise = new _promise2.default(function (resolve) {
    return resolvePromise = resolve;
  });
  Object.defineProperty(promise, 'resolve', { value: resolvePromise });

  if (arguments.length === 1) {
    resolvePromise(arguments.length <= 0 ? undefined : arguments[0]);
  }

  return promise;
};

var getEventTypes = exports.getEventTypes = function getEventTypes(viewModels, subscribers) {
  var eventTypes = {};

  (0, _keys2.default)(subscribers.viewModels).forEach(function (viewModelName) {
    if (!subscribers.viewModels[viewModelName]) {
      return;
    }

    var projection = (0, _extends3.default)({}, viewModels.find(function (_ref) {
      var name = _ref.name;
      return name === viewModelName;
    }).projection);
    delete projection.Init;

    (0, _keys2.default)(projection).forEach(function (eventType) {
      eventTypes[eventType] = true;
    });
  });

  return (0, _keys2.default)(eventTypes);
};

var getAggregateIds = exports.getAggregateIds = function getAggregateIds(viewModels, subscribers) {
  if (subscribers.aggregateIds['*'] > 0) {
    return '*';
  }

  return (0, _keys2.default)(subscribers.aggregateIds).filter(function (aggregateId) {
    return subscribers.aggregateIds[aggregateId];
  });
};

var createOrderedFetch = exports.createOrderedFetch = function createOrderedFetch() {
  var orderedFetchPromise = _promise2.default.resolve();

  return function (url, options) {
    return new _promise2.default(function (resolveResult) {
      orderedFetchPromise = orderedFetchPromise.then((0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!true) {
                  _context.next = 15;
                  break;
                }

                _context.prev = 1;
                _context.t0 = resolveResult;
                _context.next = 5;
                return fetch(url, options);

              case 5:
                _context.t1 = _context.sent;
                return _context.abrupt('return', (0, _context.t0)(_context.t1));

              case 9:
                _context.prev = 9;
                _context.t2 = _context['catch'](1);
                _context.next = 13;
                return new _promise2.default(function (resolve) {
                  return setTimeout(resolve, 1000);
                });

              case 13:
                _context.next = 0;
                break;

              case 15:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, undefined, [[1, 9]]);
      })));
    });
  };
};